/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dashboard2014;

import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URL;
import java.net.URLConnection;
import java.util.concurrent.Semaphore;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;

/**
 *
 * @author Robotics
 */
public class RecordingStreamFrameGrabber implements FrameGrabber, Runnable {

    public static final int PAUSE_TIMEOUT = 2413;
    public static final int READ_TIMEOUT = 822;

    private final FrameNotifier out;
    private volatile BufferedImage img;
    private volatile int team;

    private static class WriteTask implements Runnable {

        private final Semaphore lock;
        private volatile String target;
        private volatile int count;
        private byte[] data;

        WriteTask() {
            lock = new Semaphore(1);
            lock();

            data = null;
            _nextRun();
        }

        private void lock() {
            try {
                lock.acquire(1);
            } catch (InterruptedException ex) {
                Logger.getLogger(RecordingStreamFrameGrabber.class.getName()).log(Level.SEVERE, null, ex);
            }
        }

        private void unlock() {
            lock.release(1);
        }

        public void notifyNewData(byte[] b) {
            unlock();
            data = b;
        }

        private void _nextRun() {
            target = Backend.getDataPath("video");
            count = 0;
        }

        public void nextRun() {
            _nextRun();
        }

        @Override
        public void run() {
            while (true) {
                lock();
                byte[] b = data;
//                new File(target).mkdirs();
//                try {
//                    new FileOutputStream(new File(target + String.format("%d.jpg", count))).write(b);
//                    count += 1;
//                } catch (IOException ex) {
//                    Logger.getLogger(RecordingStreamFrameGrabber.class.getName()).log(Level.SEVERE, null, ex);
//                }
            }
        }
    }

    private final WriteTask writer;

    public RecordingStreamFrameGrabber(FrameNotifier o) {
        out = o;
        img = null;
        Thread t = new Thread(this, "Recording Stream Frame Grabber");
        t.start();
        team = 0;
        writer = new WriteTask();
        (new Thread(writer)).start();
    }

    @Override
    public void setIP(int team) {
        this.team = team;
    }

    @Override
    public BufferedImage getLatestImage() {
        return img;
    }

    private static byte[] readUpToByteString(InputStream s, int[] key) throws IOException {
        ByteArrayOutputStream o = new ByteArrayOutputStream();
        for (int i = 0; i < key.length;) {
            int b = s.read();
            o.write(b);
            if (b == key[i]) {
                i++;
            } else {
                i = 0;
            }
        }
        return o.toByteArray();
    }

    private static void writeIntBytes(OutputStream o, int[] key) throws IOException {
        for (int i = 0; i < key.length; i++) {
            o.write(key[i]);
        }
    }

    final int[] JPEG_SOI = {0xFF, 0xD8};
    final int[] JPEG_EOI = {0xFF, 0xD9};

    private String getAddr(int team) {
        //return "http://147.134.38.233/axis-cgi/mjpg/video.cgi";
        return String.format("http://%s/axis-cgi/mjpg/video.cgi", Backend.getCameraIP(team));
    }

    @Override
    public void run() {
        final ByteArrayOutputStream buffer = new ByteArrayOutputStream();
        while (true) {
            int cteam = team;
            try {
                URLConnection target = new URL(getAddr(cteam)).openConnection();
                target.setReadTimeout(READ_TIMEOUT);
                InputStream is = target.getInputStream();

                writer.nextRun();
                while (cteam == team) {
                    buffer.reset();
                    // this section is quite time intensive (is it CPU intensive?)
                    readUpToByteString(is, JPEG_SOI);
                    writeIntBytes(buffer, JPEG_SOI);
                    buffer.write(readUpToByteString(is, JPEG_EOI));
                    byte[] data = buffer.toByteArray();
                    img = ImageIO.read(new ByteArrayInputStream(data));
                    out.notifyNewFrame();
                    writer.notifyNewData(data);
                }
            } catch (IOException ex) {
                System.out.println(ex.getMessage());
                try {
                    Thread.sleep(PAUSE_TIMEOUT);
                } catch (InterruptedException ex1) {

                }
            }
        }
    }
}
