/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dashboard2014;

import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.JComboBox;
import javax.swing.JTextField;

/**
 *
 * @author Robotics
 */
public class TeamNumChooser {

    private int team;
    private final JTextField text;
    private final JComboBox<SItem> combo;

    public static final SItem[] options = {
        new SItem("1511 Robot", 1511)
    };

    public TeamNumChooser(JTextField j, JComboBox<SItem> b, int def) {
        text = j;
        combo = b;

        for (SItem s : options) {
            combo.addItem(s);
        }

        // this must be the last option
        combo.addItem(new SItem("Custom", 0));

        text.addPropertyChangeListener("value", new PropertyChangeListener() {
            @Override
            public void propertyChange(PropertyChangeEvent evt) {
                synchronizeCombo();
                if (numChangeListener != null) {
                    numChangeListener.run();
                }
            }
        });
        combo.addItemListener(new ItemListener() {
            @Override
            public void itemStateChanged(ItemEvent e) {
                synchronizeText();
                if (numChangeListener != null) {
                    numChangeListener.run();
                }
            }
        });
        team = def;
        text.setText(String.valueOf(team));
        synchronizeCombo();

        numChangeListener = null;
    }

    private void synchronizeCombo() {
        int num = getNumber();
        for (int i = 0; i < combo.getItemCount(); i++) {
            if (combo.getItemAt(i).toInt() == num && combo.getSelectedIndex() != i) {
                combo.setSelectedIndex(i);
                return;
            }
        }

        combo.setSelectedIndex(combo.getItemCount() - 1);
    }

    private void synchronizeText() {
        int choice = combo.getItemAt(combo.getSelectedIndex()).toInt();
        if (choice != 0) {
            text.setText(String.valueOf(choice));
        }
    }

    public int getNumber() {
        try {
            team = Integer.parseInt(text.getText());
        } catch (NumberFormatException e) {
        }
        return team;
    }

    public void setNumber(int team) {
        this.team = team;
        this.text.setText(String.valueOf(team));
        synchronizeCombo();
    }

    private Runnable numChangeListener;

    public void setNumberChangeListener(Runnable i) {
        numChangeListener = i;
    }
}
