/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dashboard2014;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.util.Random;
import javax.swing.JPanel;

/**
 *
 * @author Robotics
 */
public class VideoOutput extends JPanel implements FrameNotifier {

    private static final long serialVersionUID = 1L;

    private FrameGrabber grabber;

    public VideoOutput() {
        super();
    }

    private static class NullGrabber implements FrameGrabber {

        @Override
        public void setIP(int team) {
        }

        @Override
        public BufferedImage getLatestImage() {
            return null;
        }
    }

    public void init(boolean fake) {
        timestamp = System.currentTimeMillis();
        if (fake) {
            grabber = new FakeFrameGrabber(this);
        } else {
            //grabber = new NullGrabber();
            grabber = new RecordingStreamFrameGrabber(this);
        }
        grabber.setIP(0);
    }

    public void setIP(int ip) {
        grabber.setIP(ip);
    }

    private static Color getRandomColor() {
        Random r = new Random();
        double h = r.nextDouble();
        double s = r.nextDouble();
        double v = r.nextDouble();
        return Color.getHSBColor((float) h, (float) (s * s), (float) (1.0 - v * v * v));
    }

    @Override
    public void paintComponent(Graphics g) {
        Image i;
        if (grabber == null ? false : (i = grabber.getLatestImage()) != null) {
            g.drawImage(i, 0, 0, this.getWidth(), this.getHeight(), null);
        } else {
            g.setColor(getRandomColor());
            g.fillRect(0, 0, this.getWidth(), this.getHeight());
        }
    }

    public BufferedImage getLastFrame() {
        return grabber == null ? null : grabber.getLatestImage();
    }

    public long getLastFrameTimestamp() {
        return timestamp;
    }

    private volatile long timestamp;

    @Override
    public void notifyNewFrame() {
        long new_time = System.currentTimeMillis();
        System.err.println(String.format("Frame time: %f", (new_time - timestamp) / 1000.0));
        timestamp = new_time;
        repaint();
    }
}
